﻿Public Class Form1

	Private ReadOnly audio As New Audio(My.Resources.CowBellAudio)
	Private ReadOnly startVolume As UInteger
	Private oldValue As Audio.Volumes

	Public Sub New()
		InitializeComponent()

		' getting volume since we'll be messing with it.
		' need to reset it back to where we started
		startVolume = audio.AudioVolume
	End Sub

	Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs)
		audio.AudioVolume = startVolume
	End Sub

	Private Sub picCowbell_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs)
		Dim value As Audio.Volumes
		Select Case Convert.ToInt32(Math.Round((e.Y / (Height * 1)) * 5))
			Case 2
				value = audio.Volumes.NORMAL
				Exit Select
			Case 3
				value = audio.Volumes.MEDIUM
				Exit Select
			Case 4
				value = audio.Volumes.HIGH
				Exit Select
			Case 5
				value = audio.Volumes.VERY_HIGH
				Exit Select
			Case Else
				'case 0: // implied with default;
				'case 1:
				value = audio.Volumes.LOW
				Exit Select
		End Select

		' no need to take the performance hit of changing the volume
		' if the values aren't different
		If oldValue <> value Then
			audio.AudioVolume = Convert.ToInt32(value)
			oldValue = value
		End If

		audio.Play()
	End Sub
	

	Private Sub picClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picClose.Click
		Close()
	End Sub

	Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		setupCowBell()
		picClose.Left = Width - picClose.Width - 3
		picClose.Top = 3
	End Sub
	
	Private Sub setupCowBell()
		' need to reset just in case
		picCowbell.Left = 0
		picCowbell.Top = 0

		picCowbell.Image = My.Resources.cowBellImage

		picCowbell.Height = Height
		picCowbell.Width = Width

		If Height > Width Then
			picCowbell.Width = calculateResize(picCowbell.Height, My.Resources.cowBellImage.Height, My.Resources.cowBellImage.Width)
		Else
			picCowbell.Height = calculateResize(picCowbell.Width, My.Resources.cowBellImage.Width, My.Resources.cowBellImage.Height)
		End If

		' center image
		picCowbell.Top = (Height - picCowbell.Height) / 2
		picCowbell.Left = (Width - picCowbell.Width) / 2
	End Sub

	Private Shared Function calculateResize(ByVal KnownResizedSide As Integer, ByVal KnownNeededSide As Integer, ByVal KnownOtherSide As Integer) As Integer
		Return Convert.ToInt32(KnownResizedSide * ((KnownOtherSide * 1) / KnownNeededSide))
	End Function

End Class
