﻿using System;
using System.IO;
using System.Media;
using System.Runtime.InteropServices;

namespace Cowbell
{
	public class Audio
	{
		[DllImport("coredll.dll")]
		private static extern int waveOutGetVolume(IntPtr hwo, out uint dwVolume);

		[DllImport("coredll.dll")]
		private static extern int waveOutSetVolume(IntPtr hwo, uint dwVolume);

		private readonly SoundPlayer sp;

		public Audio(byte[] AudioResource)
		{
			sp = new SoundPlayer(new MemoryStream(AudioResource));
			sp.Load();
		}

		public void Play()
		{
			sp.Play();
		}

		public void PlayLoop()
		{
			sp.PlayLooping();
		}

		public void Stop()
		{
			sp.Stop();
		}

		public static uint Volume
		{
			get
			{
				uint _volume;
				waveOutGetVolume(IntPtr.Zero, out _volume);
				return _volume;
			}

			set
			{
				waveOutSetVolume(IntPtr.Zero, value);
			}
		}

		// These are interesting
		// I'm not sure where these exact #'s come from however
		// they work.
		// What is weirder is you can do like int.min
		// and it will be off
		// int.max will do a very high
		// so I'm not sure where the exact value document is

		public enum Volumes
		{
			OFF = 0,
			LOW = 858993459,
			NORMAL = 1717986918,
			MEDIUM = -1717986919,
			HIGH = -858993460,
			VERY_HIGH = -1
		}
	}
}
