﻿using System;
using System.Windows.Forms;

namespace Cowbell
{
	public partial class Form1 : Form
	{
		private readonly Audio audio = new Audio(Properties.Resources.CowBellAudio);
		private readonly uint startVolume;

		public Form1()
		{
			InitializeComponent();

			// getting volume since we'll be messing with it.
			// need to reset it back to where we started
			startVolume = Audio.Volume;
		}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			Audio.Volume = startVolume;
		}

		Audio.Volumes oldValue;
		private void picCowbell_MouseDown(object sender, MouseEventArgs e)
		{
			Audio.Volumes value;
			switch ((int)Math.Round((e.Y / (Height * 1.0)) * 5))
			{
				//case 0: // implied with default;
				//case 1:
				default:
					value = Audio.Volumes.LOW;
					break;
				case 2:
					value = Audio.Volumes.NORMAL;
					break;
				case 3:
					value = Audio.Volumes.MEDIUM;
					break;
				case 4:
					value = Audio.Volumes.HIGH;
					break;
				case 5:
					value = Audio.Volumes.VERY_HIGH;
					break;
			}

			// no need to take the performance hit of changing the volume
			// if the values aren't different
			if( oldValue != value)
			{
				Audio.Volume = (uint) value;
				oldValue = value;
			}

			audio.Play();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			setupCowBell();
			picClose.Left = Width - picClose.Width - 3;
			picClose.Top = 3;
		}

		private void pictureBox1_Click(object sender, EventArgs e)
		{
			Close();
		}

		private void setupCowBell()
		{
			// need to reset just in case
			picCowbell.Left = 0;
			picCowbell.Top = 0;

			picCowbell.Image = Properties.Resources.cowBellImage;

			picCowbell.Height = Height;
			picCowbell.Width = Width;

			if (Height > Width)
				picCowbell.Width = calculateResize(picCowbell.Height, Properties.Resources.cowBellImage.Height, Properties.Resources.cowBellImage.Width);
			else
				picCowbell.Height = calculateResize(picCowbell.Width, Properties.Resources.cowBellImage.Width, Properties.Resources.cowBellImage.Height);

			// center image
			picCowbell.Top = (Height - picCowbell.Height) / 2;
			picCowbell.Left = (Width - picCowbell.Width) / 2;
		}

		private static int calculateResize(int KnownResizedSide, int KnownNeededSide, int KnownOtherSide)
		{
			return (int)(KnownResizedSide * ((KnownOtherSide * 1.0) / KnownNeededSide));
		}
	}
}